<?php

namespace Teknisa\CADEST\Controllers;

use \Zeedhi\Framework\DTO;
use \Zeedhi\Framework\DTO\Response\Error;
use \Zeedhi\Framework\DataSource\DataSet;
use \Zeedhi\Framework\DataSource\FilterCriteria;
use \Teknisa\Libs\Util\Environment;
use \Zeedhi\Framework\DataSource\Manager;
use \Zeedhi\Framework\DataSource\ParameterBag;
use \Teknisa\Libs\Service\CRUD;

class ProdArvoreProdCrud extends \Teknisa\CADEST\Controllers\TeknisaCrud{

	protected $dataSourceName = 'prodarvoreprod';
	protected $environment;
	protected $dataSourceManager;
	protected $parameterBagColumns = array();
	protected $messages = array(
		"APP-00000" => 'The email account that you tried to reach does not exist.',
		"APP-00001" => 'The password you entered is not valid.',
		"APP-00002" => 'O produto já se encontra cadastrado para outro grupo no mesmo tipo de árvore.'
	);

	function __construct(CRUD $crudService, ParameterBag $parameterBag, $environment, $dataSourceManager){
		$this->dataSourceManager = $dataSourceManager;
		$this->environment = $environment;
		parent::__construct($crudService, $parameterBag);
	}
	

	public function save(DTO\Request $request, DTO\Response $response){

		$row = $request->getRow();

		if($row['__is_new']){
			$condition = array(
				array(
					"columnName" => "CDPRODUTO",
					"operator" => "=",
					"value" => $row["CDPRODUTO"]
				),
				array(
					"columnName" => "NRTPARVPROD",
					"operator" => "=",
					"value" => $row["NRTPARVPROD"]
				)
			);

			$filterCriteria = new FilterCriteria($this->dataSourceName, $condition);
      $dataSet = $this->dataSourceManager->findBy($filterCriteria);
      $registrosEncontrados = $dataSet->getRows();

      if(empty($registrosEncontrados)){
          parent::save($request, $response);
      } else {
          $response->setError(new DTO\Response\Error($this->messages['APP-00002'], 1));
      }
    } else {
      parent::save($request, $response);
    }

	}
}